/*
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Id: cast.gi,v 1.1 2002/08/14 11:59:22 malekith Exp $
 *
 * Cast - C interface to Ast. This stuff is used by parser.y.
 */

open Ast;

expr make_expr(raw_expr raw, location loc);
<'a>located make_located('a data, location loc);
ref_record make_ref_record(<var_symbol>bindable name);
vardef make_vardef(ty var_type, <var_symbol>bindable name);
<'a>field make_field(ty fld_type, <'a>bindable fld_symbol, location l);
nl_decl make_tydef(id name, <id>List::t tyvars, ty typ, location l);
nl_decl make_fn_decl(vardef header, string exportas, stmt body);
ty bare_fn_type(ty ret, <*[ty, <id>option]>List::t args);
stmt make_vardefs(ty t, <*[<var_symbol>bindable, stmt]>List::t vars);
nl_expr make_lambda(ty t, stmt body);
nl_stmt make_lambda_assign(vardef v, stmt body);
nl_stmt make_break(break_kind kind, <li_symbol>bindable sym);
nl_stmt make_loop(string label, stmt body, stmt inc);
namedexpr make_namedexpr(<var_symbol>bindable sym, expr ex);
named_pattern make_named_pattern(<var_symbol>bindable sym, pattern pat);
ty make_named_type(<ty_symbol>bindable tydef, <ty>List::t parms);
try_record make_try_record(stmt body, <*[pattern, stmt]>List::t try_with,
			   stmt tfinally);
expr make_int_const(string, location);
expr make_float_const(string, location);
void raise_located(location l, string msg);
lambda_record make_section_record(stmt s);
sini_expr make_sini_expr(<sf_symbol>bindable sym, expr ex);
ty make_tyvar(id n);
